#ifndef _KILIB_FILE_H_
#define _KILIB_FILE_H_
#include "types.h"
#include "memory.h"
#ifndef __ccdoc__
namespace ki {
#endif



//=========================================================================
//@{ @pkg ki.StdLib //@}
//@{
//	ȈՃt@CǍ
//
//	t@C}bsOp̂ŁAȒPłƍłB
//	ƂɁA4GB܂łJ܂B
//@}
//=========================================================================

class FileR : public Object
{
public:

	FileR();
	~FileR();

	//@{
	//	J
	//	@param fname t@C
	//	@return Jǂ
	//@}
	bool Open( const TCHAR* fname );

	//@{
	//	
	//@}
	void Close();

public:

	//@{ t@CTCY //@}
	ulong size() const;

	//@{ t@Ce}bvAhX擾 //@}
	const uchar* base() const;

private:

	HANDLE      handle_;
	HANDLE      fmo_;
	ulong       size_;
	const void* basePtr_;

private:

	NOCOPY(FileR);
};



//-------------------------------------------------------------------------

inline ulong FileR::size() const
	{ return size_; }

inline const uchar* FileR::base() const
	{ return static_cast<const uchar*>(basePtr_); }



//=========================================================================
//@{
//	ȈՃt@C
//
//	ĂƁ[Ƀobt@OB
//@}
//=========================================================================

class FileW : public Object
{
public:

	FileW();
	~FileW();

	//@{ J //@}
	bool Open( const TCHAR* fname, bool creat=true );

	//@{  //@}
	void Close();

	//@{  //@}
	void Write( const void* buf, ulong siz );

	//@{ ꕶ //@}
	void WriteC( uchar ch );

public:

	void Flush();

private:

	const int    BUFSIZE;
	HANDLE       handle_;
	uchar* const buf_;
	ulong        bPos_;

private:

	NOCOPY(FileW);
};



//=========================================================================

}      // namespace ki
#endif // _KILIB_FILE_H_
